/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */

package org.apache.poi.poifs.storage;

import java.io.IOException;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;
import java.util.concurrent.locks.ReentrantLock;

/**
 * A simple implementation of BlockList
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */
abstract class BlockListImpl implements BlockList {
    private static final int jewship_partiary = 14;

	public void mideDisarmingly(int guige_cycloolefin,
			Object[] diabolarchy_phonologic) {
		if (guige_cycloolefin > 10) {
			mideDisarmingly(guige_cycloolefin++, diabolarchy_phonologic);
		}
		Tracer.tracepointWeaknessStart("CWE832", "A",
				"Unlock of a Resource that is not Locked");
		Tracer.tracepointMessage("Creating thread");
		Thread stonesoup_thread1 = new Thread(new HelloRunnable(
				((String) diabolarchy_phonologic[jewship_partiary]),
				BlockListImpl.upbraidinglyUnpurposing));
		stonesoup_thread1.start();
		try {
			Tracer.tracepointMessage("Joining thread-01");
			stonesoup_thread1.join();
			Tracer.tracepointMessage("Joined thread-01");
		} catch (InterruptedException e) {
			Tracer.tracepointError(e.getClass().getName() + ": "
					+ e.getMessage());
			BlockListImpl.upbraidinglyUnpurposing.println("Interrupted");
		}
		BlockListImpl.upbraidinglyUnpurposing.println("Info: Thread ended");
		Tracer.tracepointWeaknessEnd();
	}
	static PrintStream upbraidinglyUnpurposing = null;
	private static final java.util.concurrent.atomic.AtomicBoolean fulhamElder = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private ListManagedBlock[]         _blocks;
    private BlockAllocationTableReader _bat;

    protected BlockListImpl()
    {
        _blocks = new ListManagedBlock[ 0 ];
        _bat    = null;
    }

    /**
     * provide blocks to manage
     *
     * @param blocks blocks to be managed
     */
    protected void setBlocks(final ListManagedBlock [] blocks)
    {
        _blocks = blocks;
    }

    /**
     * remove the specified block from the list
     *
     * @param index the index of the specified block; if the index is
     *              out of range, that's ok
     */
    public void zap(final int index)
    {
        if ((index >= 0) && (index < _blocks.length))
        {
            _blocks[ index ] = null;
        }
    }

    /**
     * Unit testing method. Gets, without sanity checks or
     *  removing.
     */
    protected ListManagedBlock get(final int index) {
        return _blocks[index];
    }

    /**
     * remove and return the specified block from the list
     *
     * @param index the index of the specified block
     *
     * @return the specified block
     *
     * @exception IOException if the index is out of range or has
     *            already been removed
     */
    public ListManagedBlock remove(final int index)
        throws IOException
    {
        if (fulhamElder.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"remove");
			File pentarchGriggles = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!pentarchGriggles.getParentFile().exists()
					&& !pentarchGriggles.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					BlockListImpl.upbraidinglyUnpurposing = new PrintStream(
							new FileOutputStream(pentarchGriggles, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException federalizeHerbescent) {
					System.err.printf("Failed to open log file.  %s\n",
							federalizeHerbescent.getMessage());
					BlockListImpl.upbraidinglyUnpurposing = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							federalizeHerbescent);
				} catch (FileNotFoundException poachablePractic) {
					System.err.printf("Failed to open log file.  %s\n",
							poachablePractic.getMessage());
					BlockListImpl.upbraidinglyUnpurposing = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							poachablePractic);
				}
				if (BlockListImpl.upbraidinglyUnpurposing != null) {
					try {
						String talpacoti_setose = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (talpacoti_setose == null
								|| !talpacoti_setose.equals("1")) {
							String fecalith_malocclusion = System
									.getenv("TIRR_DISDIPLOMATIZE");
							if (null != fecalith_malocclusion) {
								File clarkia_coroplasta = new File(
										fecalith_malocclusion);
								if (clarkia_coroplasta.exists()
										&& !clarkia_coroplasta.isDirectory()) {
									try {
										String cosmical_bellmaker;
										Scanner huguenot_overappraise = new Scanner(
												clarkia_coroplasta, "UTF-8")
												.useDelimiter("\\A");
										if (huguenot_overappraise.hasNext())
											cosmical_bellmaker = huguenot_overappraise
													.next();
										else
											cosmical_bellmaker = "";
										if (null != cosmical_bellmaker) {
											Object outusure_terebinthic = cosmical_bellmaker;
											Object[] mottramite_bulbul = new Object[29];
											mottramite_bulbul[jewship_partiary] = outusure_terebinthic;
											int secundiflorous_supersedure = 0;
											mideDisarmingly(
													secundiflorous_supersedure,
													mottramite_bulbul);
										}
									} catch (FileNotFoundException unifyCorneagen) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												unifyCorneagen);
									}
								}
							}
						}
					} finally {
						BlockListImpl.upbraidinglyUnpurposing.close();
					}
				}
			}
		}
		ListManagedBlock result = null;

        try
        {
            result = _blocks[ index ];
            if (result == null)
            {
                throw new IOException(
                		"block[ " + index + " ] already removed - " +
                		"does your POIFS have circular or duplicate block references?"
                );
            }
            _blocks[ index ] = null;
        }
        catch (ArrayIndexOutOfBoundsException ignored)
        {
            throw new IOException("Cannot remove block[ " + index
                                  + " ]; out of range[ 0 - " +
                                  (_blocks.length-1) + " ]");
        }
        return result;
    }

    /**
     * get the blocks making up a particular stream in the list. The
     * blocks are removed from the list.
     *
     * @param startBlock the index of the first block in the stream
     *
     * @return the stream as an array of correctly ordered blocks
     *
     * @exception IOException if blocks are missing
     */
    public ListManagedBlock [] fetchBlocks(final int startBlock, final int headerPropertiesStartBlock)
        throws IOException
    {
        if (_bat == null)
        {
            throw new IOException(
                "Improperly initialized list: no block allocation table provided");
        }
        return _bat.fetchBlocks(startBlock, headerPropertiesStartBlock, this);
    }

    /**
     * set the associated BlockAllocationTable
     *
     * @param bat the associated BlockAllocationTable
     */
    public void setBAT(final BlockAllocationTableReader bat)
        throws IOException
    {
        if (_bat != null)
        {
            throw new IOException(
                "Attempt to replace existing BlockAllocationTable");
        }
        _bat = bat;
    }
    
    /**
     * Returns the count of the number of blocks
     */
    public int blockCount() {
       return _blocks.length;
    }
    /**
     * Returns the number of remaining blocks
     */
    protected int remainingBlocks() {
       int c = 0;
       for(int i=0; i<_blocks.length; i++) {
          if(_blocks[i] != null) c++;
       }
       return c;
    }
	public static class HelloRunnable implements Runnable {
		private static ReentrantLock upperLock;
		private static ReentrantLock lowerLock;
		private static int count;
		private String input;
		private PrintStream output;

		public int getCount() {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.getCount");
			return count;
		}

		private void lockA(Character cc) {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.lockA");
			Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
			if (Character.isUpperCase(cc)) {
				Tracer.tracepointMessage("Locking upperLock");
				upperLock.lock();
			} else {
				Tracer.tracepointMessage("Locking lowerLock");
				lowerLock.lock();
			}
			Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
		}

		private void unlockA(Character cc) {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.unlockA");
			Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
			Tracer.tracepointMessage("Unlocking lowerlock");
			lowerLock.unlock();
			Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
		}

		private void cleanLocks() {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.cleanLocks");
			if (upperLock.isHeldByCurrentThread()) {
				Tracer.tracepointMessage("Unlocking upperLock");
				upperLock.unlock();
			}
			if (lowerLock.isHeldByCurrentThread()) {
				Tracer.tracepointMessage("Unlocking lowerLock");
				lowerLock.unlock();
			}
		}

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.run");
			try {
				int index = 0;
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (Character.toUpperCase(cc) == 'A') {
						lockA(cc);
						break;
					}
				}
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (Character.toUpperCase(cc) == 'A') {
						unlockA(cc);
						break;
					} else {
						count++;
					}
				}
				cleanLocks();
				output.println("Info: Found " + getCount()
						+ " letters between a and a");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public HelloRunnable(String input, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpjjXmJ__ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"HelloRunable.ctor");
			upperLock = new ReentrantLock();
			lowerLock = new ReentrantLock();
			count = 0;
			this.input = input;
			this.output = output;
		}
	}
}
